/* app.cc
** Copyright (C) 1999 Juan Pablo Romero <juan_pablo_22@yahoo.com>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


#if HAVE_CONFIG_H
#   include <config.h>
#endif

#include <strstream>
#include <gnome.h>

#include "global.h"
#include "superficie.h"
#include "dialog-object-properties.h"
#include "dialog-load.h"
#include "support.h"
#include "superficie.h"
#include "gnome-sup.h"

void
app_delete_node(GNode* node)
{
    TheScene.remove(node);
    rebuild_tree();
    app_select_node( TheScene.selected_node() );
    TheScene.redraw();
}


void
app_insert_object(GtkWidget* w, gpointer data)
{
    load_cb(w, NULL);
}

void
app_insert_node(GNode* node)
{

}

void
app_edit_node(GNode* node)
{
    BaseObject* ob;
    gchar* argv[2];
    gchar* pwd;
    PRINT_F_NAME();

    ob = BASE_OBJECT(node);
    
    argv[0] = gnome_config_get_string("/editor/Editor/EDITOR");

    if (!argv[0] )
        argv[0] = g_getenv("XEDITOR");

    if( !argv[0] )
        argv[0] = "fte";
        
    //argv[1] = ob->file_name();
    argv[1] = "";

    pwd = g_get_current_dir();

    g_warning("argv[0] = %s", argv[0]);
    g_warning("argv[1] = %s", argv[1]);


    if( !strcmp("", argv[1]) )
        return;
        
    gnome_execute_async (pwd, 2,  argv);
    
}

// 'ctree_node_found' is a global variable defined in 'tree.cc'
// It contains the GtkCTree node corresponding to the given GNode.

void
app_select_node(GNode* gnode)
{
    if( TheTreeW ) {
        // update the object properties dialog
        GtkWidget* ctree = lookup_widget(TheTreeW, "ctree");

        if ( gnode != TheScene.gnode() ) {
            // Expande el nodo padre
            gtk_ctree_pre_recursive(GTK_CTREE(ctree), NULL, find_gtkctreenode_from_gnode, gnode->parent);
            gtk_ctree_expand ( GTK_CTREE(ctree), ctree_node_found );
        }
        gtk_ctree_pre_recursive(GTK_CTREE(ctree), NULL, find_gtkctreenode_from_gnode, gnode);
        // this will cause the emition of the 'select_row' signal
        // TheScene._selected_gnode is updated in 'on_ctree_tree_select_row'.
        gtk_ctree_select(GTK_CTREE(ctree), ctree_node_found);
    }
    else {
        // just select the gnode
        TheScene.selected_node(gnode);
    }
}