/* dialog-load.cc
** Copyright (C) 1999 Juan Pablo Romero <juan_pablo_22@yahoo.com>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


#if HAVE_CONFIG_H
#       include <config.h>
#endif

#include <gnome.h>

#include "global.h"
#include "gnome-sup.h"
#include "superficie.h"

static gchar* prog_name;

static void
    file_ok_sel (GtkWidget *button, gpointer data)
{

    GtkWidget* filew = gtk_widget_get_toplevel(button);
    gchar*     tmp =
        g_strdup( gtk_file_selection_get_filename(GTK_FILE_SELECTION(filew)) );
    gchar* argv[2];

    PRINT_F_NAME();

    /* If path ends with '/' (directory) don't try to load the file */

    if ( tmp[ strlen(tmp) - 1 ] != '/' ) {
        update_window_from_file_async(tmp);
    }

    gtk_widget_hide(filew);
}



void
load_cb (GtkWidget* w, gpointer data)
{
    static GtkWidget *filew = NULL;
    GtkAccelGroup *accel_group;
    
    PRINT_F_NAME();
    
    if( !filew ) {
        filew = gtk_file_selection_new( _("Select file...") );
        gtk_window_position( GTK_WINDOW (filew), GTK_WIN_POS_MOUSE );

        accel_group = gtk_accel_group_new ();
        gtk_window_add_accel_group (GTK_WINDOW (filew), accel_group);
        gtk_widget_add_accelerator (filew, "hide", accel_group,
                                    GDK_Escape, 0, GTK_ACCEL_VISIBLE);

        gtk_signal_connect( GTK_OBJECT (filew), "destroy",
                            GTK_SIGNAL_FUNC( gtk_widget_destroy ),
                            &filew );
        gtk_signal_connect(GTK_OBJECT( GTK_FILE_SELECTION (filew)->ok_button ),
                           "clicked", GTK_SIGNAL_FUNC(file_ok_sel),
                           data );
        gtk_signal_connect_object( GTK_OBJECT(filew), "delete_event",
                                   GTK_SIGNAL_FUNC( gtk_widget_hide ),
                                   GTK_OBJECT (filew));
        gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button),
                                   "clicked", GTK_SIGNAL_FUNC(gtk_widget_hide),
                                   GTK_OBJECT (filew));
    }
    
    if( !GTK_WIDGET_VISIBLE (filew) )
        gtk_widget_show(filew);
}


