/***************************************************************************
                          light_material.h  -  description
                             -------------------
    begin                : Fri Dec 10 1999
    copyright            : (C) 1999 by Juan Pablo Romero Mndez
    email                : juan_pablo_22@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef _LIGHT_MATERIAL_H
#define _LIGHT_MATERIAL_H

#include "util.h"
#include "svector.h"
#include <glib.h>


class SLight {

protected:

    ATTRIBUTE(active, gboolean);

    SVECTOR_ATTRIBUTE(position,     4);
    SVECTOR_ATTRIBUTE(diffuse,      4);
    SVECTOR_ATTRIBUTE(ambient,      4);
    SVECTOR_ATTRIBUTE(specular,     4);

public:

    SLight() {
        _position = SVector<4>( 0.0, 0.0, 1.0, 0.0 );
        _diffuse  = SVector<4>( 1.0, 1.0, 1.0, 1.0 );
        _ambient  = SVector<4>( 0.01, 0.01, 0.01, 1.0 );
        _specular = SVector<4>( 1.0, 1.0, 1.0, 1.0 );
        _active   = FALSE;
    }

};



class SMaterial {

protected:
    ATTRIBUTE( shininess, gfloat );

    SVECTOR_ATTRIBUTE( ambiend_and_diffuse, 4 );
    SVECTOR_ATTRIBUTE( specular,            4 );
    SVECTOR_ATTRIBUTE( emission,            4 );

public:

    SMaterial() {
        _ambiend_and_diffuse = SVector<4>( 0.5, 0.5, 0.5, 1 );
        _specular            = SVector<4>( 0.0, 0.0, 0.0, 1 );
        _emission            = SVector<4>( 0.0, 0.0, 0.0, 1 );
        _shininess           = 0.0;
    }
};

#endif