/***************************************************************************
                          lights.h  -  description
                             -------------------
    begin                : Fri Dec 10 1999
    copyright            : (C) 1999 by Juan Pablo Romero Mndez
    email                : juan_pablo_22@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef _LIGHTS_H
#define _LIGHTS_H

#include "svector.h"
#include "light_material.h"

#include <glib.h>
#include <deque>
#include <GL/gl.h>


#define MAX_LIGHTS 8

class SceneLights {

    deque<SLight> _slights;
    typeof(GL_LIGHT0) * S_GL_LIGHTS;

public:

    SceneLights ();
    ~SceneLights();

    void enable_all     ();
    void disable_all    ();
    void gl_enable_all  ();
    void gl_disable_all ();
    void update_position();
    void update_diffuse ();
    void update_ambient ();
    void update_specular();
    void update_ambient (gint light, gfloat* val = NULL);
    void update_position(gint light, gfloat* val);
    void update_diffuse (gint light, gfloat* val = NULL);
    void update_specular(gint light, gfloat* val = NULL);
    void update_active  (gint light, gboolean val);
    void erase			    (gint light);

    void erase_all ();
    void update_all();
    void push_back ();

    deque<SLight> & slights () { return _slights; }
    void make_defaults();
    gboolean some_active();
    gint size() { return _slights.size(); }

    SLight & operator[] (gint i) {
        g_assert(i < _slights.size() );
        return _slights[i];
    }

};


#endif