/***************************************************************************
                          line.cc  -  description
                             -------------------
    begin                : Fri Dec 10 1999
    copyright            : (C) 1999 by Juan Pablo Romero Mndez
    email                : juan_pablo_22@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "line.h"
#include "read_data.h"
#include "util.h"

#include <GL/gl.h>
#include <strstream>

Line::Line(gboolean array)
{
    _type  = LINE;
    _array = array;
}


void
Line::parse_xml_node(xmlDocPtr doc, xmlNsPtr ns, xmlNodePtr cur)
{
    // This ends the nodes on this level
    while (cur != NULL) {
        if( EQSTR(cur->name, "Index") && (cur->ns == ns)) {
            parse_array(_index,
                        (gchar*) xmlNodeListGetString(doc, cur->childs, 1),
                        (gchar*) xmlGetProp(cur, "Length"));
        }
        cur = cur->next;
    }
}


void
Line::initialize()
{
    //TODO: fix this!!!
    static guint _loaded = 0;
    ostrstream n;
    n << "line" << _loaded++ << ends;
    _name = n.str();
    n.freeze(0);
    //

    _index = vector<guint>(_vertex.size());
    _for_each(i, _index.size(), _index[i] = i;);

}



void
Line::draw(void)
{
    Object::draw();

    { // Until I learn how to handle the lighting with lines, disable lighting
        slights.gl_disable_all();

        glDisableClientState(GL_NORMAL_ARRAY);
    }

    if( smooth_lines() ) {
        glEnable (GL_LINE_SMOOTH);
        glEnable (GL_BLEND);
        glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    }

    glLineWidth (lines_width ());

    glDrawElements( _array ? GL_LINES : GL_LINE_STRIP,
                    _index.size(), GL_UNSIGNED_INT, _index.begin() );

    if( smooth_lines() ) {
        glDisable (GL_LINE_SMOOTH);
        glDisable (GL_BLEND);
    }


    { //Enable lighting again
        glEnableClientState(GL_NORMAL_ARRAY);
        slights.gl_enable_all();
    }

}

