/***************************************************************************
                          point.cc  -  description
                             -------------------
    begin                : Fri Dec 10 1999
    copyright            : (C) 1999 by Juan Pablo Romero Mndez
    email                : juan_pablo_22@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "point.h"
#include "read_data.h"
#include "util.h"

#include <GL/gl.h>
#include <strstream>

Point::Point()
{
    _type  = POINT;
}


void
Point::parse_xml_node(xmlDocPtr doc, xmlNsPtr ns, xmlNodePtr cur) {}

void
Point::initialize()
{
    //TODO: fix this!!!
    static guint _loaded = 0;
    ostrstream n;
    n << "point" << _loaded++ << ends;
    _name = n.str();
    n.freeze(0);
    //

    _index = vector<guint>(_vertex.size());
    _for_each(i, _index.size(), _index[i] = i;);
}



void
Point::draw(void)
{
    Object::draw();

    { // Until I learn how to handle the lighting
        slights.gl_disable_all();
        glDisableClientState(GL_NORMAL_ARRAY);
    }

    if( smooth_edges() ) {
        glEnable (GL_POINT_SMOOTH);
        glEnable (GL_BLEND);
        glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    }

    glPointSize(points_width ());
    glPointSize(lines_width ());

    glDrawElements(GL_POINTS, _index.size(),
                   GL_UNSIGNED_INT, (guint*) _index.begin());

    if( smooth_edges() ) {
        glDisable (GL_POINT_SMOOTH);
        glDisable (GL_BLEND);
    }


    { //Enable lighting again
        glEnableClientState(GL_NORMAL_ARRAY);
        slights.gl_enable_all();
    }

}

