/***************************************************************************
                          polygon.h  -  description
                             -------------------
    begin                : Fri Dec 10 1999
    copyright            : (C) 1999 by Juan Pablo Romero Mndez
    email                : juan_pablo_22@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef _POLYGON_H
#define _POLYGON_H

#include "object.h"
#include "sarray.h"

#include <vector>
#include <parser.h>

class Polygon : public Object
{
    vector<guint>         _index;
    VectorArray<gfloat>  _normal;
    VectorArray<gfloat> _tangente;
    
public:
    Polygon();
    ~Polygon();

    void draw           (void);
    void draw_normals   ();
    void initialize     ();
    void parse_xml_node (xmlDocPtr doc, xmlNsPtr ns, xmlNodePtr cur);
    void generate_normal_vectors (void);
    void update_normal_tangent_vectors(void);
};

#endif




