/***************************************************************************
                          read_data.cc  -  description
                             -------------------
    begin                : Fri Dec 10 1999
    copyright            : (C) 1999 by Juan Pablo Romero Mndez
    email                : juan_pablo_22@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "util.h"
#include "sup_global.h"
#include "read_data.h"

#include <glib.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <string.h>
#include <ctype.h>
#include <setjmp.h>


/*
gint read_word_from_stream(ifstream & source, gchar* word_tmp)
{
    gint j = 0;
    gint c;
    while ( (c = source.get()) != EOF && !isalnum(c) && c != '-' && c != '.' );
    if( c == EOF )
        return FALSE;
    ungetc(c, source);
    while ( isalnum( c = source.getc() )  || c == '.' || c == '-' )
        word_tmp[j++] = c;
    word_tmp[j] = '\0';
    ungetc(c, source);
    return TRUE;
}
*/

gint
get_word(gchar * data, guint & data_pos, gchar * word)
{
    gint j = 0;
    gchar c;

    while ( (c = data[data_pos++]) != '\0' && !isalnum(c) && c != '-' && c != '.' );
    if( c == '\0' )
        return FALSE;

    data_pos --;

    // read the word (max word size = 40)
    // TODO: find if making 'word' a dynamic array doesn't hurt performance too much.

    while ( (isalnum( c = data[data_pos++] ) || c == '.' || c == '-') && j < 40 )
        word[j++] = c;
    word[j] = '\0';

    data_pos --;

    return TRUE;
}


void
parse_array(VectorArray<gfloat> & array, gchar * data, gchar * length)
{
    gchar word[40];
    guint data_pos = 0;

    array = VectorArray<gfloat>(atoi(length)/3);

    for (gint i=0; i < array.size() * 3; i++) {
        get_word(data, data_pos, word);
         (&array)[i] = atof(word);
    }
}


void
parse_array(vector<guint> & array, gchar * data, gchar * length)
{
    gchar word[40];
    guint data_pos = 0;

    array = vector<guint>(atoi(length));

    for (gint i=0; i < array.size(); i++) {
        get_word(data, data_pos, word);
         array[i] = atoi(word);
    }
}



gint
read_word_from_stream(FILE* source, gchar* word_tmp)
{
    gint j = 0;
    gint c;

    /* go to the next letter or digit on stream */
    while ( (c = getc(source)) != EOF && !isalnum(c) && c != '-' && c != '.' );
    if( c == EOF )
        return FALSE;
    /* return the last character read to stream  */
    ungetc(c, source);

    /* read the word */
    while ( isalnum( c = getc(source) )  || c == '.' || c == '-' )
        word_tmp[j++] = c;
    word_tmp[j] = '\0';

    ungetc(c, source);
    return TRUE;
}



gint read_point_from_stream(FILE* fp, gfloat* array )
{
    gchar word_tmp[40];
    gint i;

    read_word_from_stream(fp, word_tmp);
    if ( strcmp( "POINT", word_tmp ) ) {
        g_warning("key not found: %s", "POINT");
        return FALSE;
    }

    for (i = 0; i < 3; i++) {
        read_word_from_stream(fp, word_tmp);
        array[i] = atof(word_tmp);
    }
    return TRUE;
}


gint read_array_from_stream(FILE* fp, gchar* key, gint* array_length, gfloat** array)
{
    gchar word_tmp[40];
    gint i;
    
    /* find "key" in stream */
    read_word_from_stream(fp, word_tmp);
    
    /* the first word found MUST be "key" */
    if ( strcmp( key, word_tmp ) ) {
        //g_warning("key not found: %s", key);
        return FALSE;
    }
    /*  read the array size */
    read_word_from_stream(fp, word_tmp);
    *array_length = atoi(word_tmp);
    *array        = new gfloat [*array_length];
    /* actually read the data */
    for (i=0; i < *array_length; i++) {

        /* Cuanto afecta el rendimiento esto?
         * En caso de ser necesario, hay que hacer
         * otra funcin, y dependiendo de la eleccin
         * del usuario, se usa la versin que se puede
         * detener o la que no se puede parar.
         */
        if( t_message.abort_loading )
            longjmp(main_loop, -1);

        read_word_from_stream(fp, word_tmp);
        *(*array+i) = atof(word_tmp);
    }

    return TRUE;
}


gint read_array_from_stream(FILE* fp, gchar* key, gint* array_length, guint** array)
{
    gchar word_tmp[40];
    gint i;
    
    read_word_from_stream(fp, word_tmp);
    if ( strcmp( key, word_tmp ) ) {
        //g_warning("key not found: %s", key);
        return FALSE;
    }
    read_word_from_stream(fp, word_tmp);
    *array_length = atoi(word_tmp);
    *array        = new guint [*array_length];
    for (i=0; i < *array_length; i++) {
        if( t_message.abort_loading )
            longjmp(main_loop, -1);
        read_word_from_stream(fp, word_tmp);
        *(*array+i) = atoi(word_tmp);
    }
    return TRUE;
}


/*
gint read_array_from_stream(ifstream & fp, gchar* key, gint & array_length, guint* & array)
{
    gchar word_tmp[40];
    fp.getline(word_tmp, sizeof(word_tmp));
    if ( string(key) != string(word_tmp) )
        return FALSE;
    fp >> array_length;
    array = new guint [array_length];
    for (gint i=0; i < array_length; i++) {
        if( t_message.abort_loading )
            longjmp(main_loop, -1);
        fp >> array[i]
    }
    return TRUE;
}
*/


gint read_array_from_stream(FILE* fp, gchar* key, vector<guint> & array)
{
    gchar word_tmp[40];

    read_word_from_stream(fp, word_tmp);

    if ( strcmp( key, word_tmp ) )
        return FALSE;

    read_word_from_stream(fp, word_tmp);

    array = vector<guint>(atoi(word_tmp));

    for (gint i=0; i < array.size(); i++) {
        if( t_message.abort_loading )
            longjmp(main_loop, -1);
        read_word_from_stream(fp, word_tmp);
        array[i] = atoi(word_tmp);
    }
    return TRUE;
}

gint read_array_from_stream(FILE* fp, gchar* key, VectorArray<gfloat> & array)
{
    gchar word_tmp[40];

    read_word_from_stream(fp, word_tmp);

    if ( strcmp( key, word_tmp ) )
        return FALSE;

    read_word_from_stream(fp, word_tmp);

    array = VectorArray<gfloat>(atoi(word_tmp)/3);

    for (gint i=0; i < array.size() * 3; i++) {
        if( t_message.abort_loading )
            longjmp(main_loop, -1);
         read_word_from_stream(fp, word_tmp);
         (&array)[i] = atof(word_tmp);
    }
    return TRUE;
}

