/***************************************************************************
                          surface.h  -  description
                             -------------------
    begin                : Fri Dec 10 1999
    copyright            : (C) 1999 by Juan Pablo Romero Mndez
    email                : juan_pablo_22@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _SURFACE_H
#define _SURFACE_H


#include "triangles.h"
#include "sup_global.h"

#include <parser.h>
#include <GL/gl.h>

class Surface : public Triangles
{
    vector<guint> _quad_index;
    vector<guint> _hline_index;

    void split_quads();

protected:
    virtual void draw_faces (void);
    virtual void draw_edges (void);
    virtual void draw_mesh  (void);
    virtual void draw_vlines(void);
    virtual void draw_hlines(void);
    virtual void draw_lines (void);


public:
    Surface();
    void parse_xml_node(xmlDocPtr doc, xmlNsPtr ns, xmlNodePtr cur);
    void initialize();
};


#endif
