/***************************************************************************
                          transformations.h  -  description
                             -------------------
    begin                : Fri Dec 10 1999
    copyright            : (C) 1999 by Juan Pablo Romero Mndez
    email                : juan_pablo_22@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef _TRANSFORMATIONS_H
#define _TRANSFORMATIONS_H

#include "util.h"
#include "svector.h"
#include <glib.h>


class Transformations {

    friend class Object;
    friend class Multiple;
    friend void rotate_about(Transformations & tr);


protected:

    SVECTOR_ATTRIBUTE(lastquat,    4);
    SVECTOR_ATTRIBUTE(curquat,     4);
    SVECTOR_ATTRIBUTE(center,      3);
    SVECTOR_ATTRIBUTE(offset,      3);

    ATTRIBUTE(node,        GNode*);

public:
    Transformations(GNode* n = NULL) {
        _lastquat[3] = 1;
        _curquat[3] = 1;
        _node = n;
    }

};



#endif