/***************************************************************************
                          triangles.h  -  description
                             -------------------
    begin                : Fri Dec 10 1999
    copyright            : (C) 1999 by Juan Pablo Romero Mndez
    email                : juan_pablo_22@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _TRIANGLES_H
#define _TRIANGLES_H

#include "object.h"
#include "sup_global.h"
#include "sarray.h"

#include <vector>
#include <glib.h>
#include <parser.h>
#include <GL/gl.h>

class Triangles : public Object
{
protected:
    vector<guint>                 _index;
    VectorArray<gfloat>          _normal;
    VectorArray<gfloat> _triangle_normal;
    VectorArray<gfloat>        _tangente;

    gint _triangle_number;

    virtual void draw_faces (void);
    virtual void draw_edges (void);
    virtual void draw_mesh  (void);
    virtual void draw_vlines(void);
    virtual void draw_hlines(void);
    virtual void draw_lines (void);

    gint find_triangles_contaning(guint i, vector<guint> & lista);

public:
    Triangles();
    virtual ~Triangles();

    virtual void        draw    (void    );

    void draw_normals           ();
    void normal_per_vertex      (gfloat angle);
    void normal_per_triangle    (void);
    void update_normal_tan_vecs (void);

    void parse_xml_node(xmlDocPtr doc, xmlNsPtr ns, xmlNodePtr cur);
    void initialize();


    /* Find a better name for this */
    void                abort   ()   { t_message.abort_loading = TRUE; }

    guint *             index   ()   { return _index.begin();  }
    gint                index_size() { return _index.size();   }
    gfloat *            tangente  () { return _tangente.ptr(); }
};


#endif
