/***************************************************************************
                          util.h  -  description
                             -------------------
    begin                : Fri Dec 10 1999
    copyright            : (C) 1999 by Juan Pablo Romero Mndez
    email                : juan_pablo_22@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _UTIL_H
#define _UTIL_H

#include <glib.h>
#include <iostream.h>
#include <stdio.h>
#include <vector>

class BaseObject;
class Transformations;
template <typename T> class VectorArray;
template <gint SIZE, typename T> class SVector;


// TODO:
// Esto debera poder definirse en "configure" (con -DDEBUG, o algo as).

#define PRINT_F_NAME() cout << ">>> " << G_GNUC_PRETTY_FUNCTION << endl
//#define PRINT_F_NAME()

/* some useful macros */
#define print_var(x) cout << #x << ": " << x << endl
//#define print_var(x)

#define _for_each(var,n,expr) for(gint var=0; var<n; var++) { expr }

//#define BASE_OBJECT(node) (node ? ((BaseObject*) node->data) : NULL)
BaseObject* BASE_OBJECT(GNode* node);


#define MAXPATHLEN 255

#define EQSTR(str,const_str) ((str) && (!strcmp (str, const_str)))


#define ATTRIBUTE(VAR, TYPE)                    \
    protected: TYPE _ ## VAR;                   \
    public:                                     \
    TYPE VAR(void)   { return _ ## VAR; }       \
    void VAR(TYPE v) { _ ## VAR = v;    }

#define VIRTUAL_ATTRIBUTE(VAR, TYPE)            \
    protected: TYPE _ ## VAR;                   \
    public:                                     \
             TYPE VAR(void)  { return _ ## VAR;}\
    virtual void VAR(TYPE v) { _ ## VAR = v;   }


#define SVECTOR_ATTRIBUTE(VAR, N)                               \
    protected: SVector<N> _##VAR;                               \
    public:                                                     \
    SVector<N> & VAR (void        )   { return _##VAR;}         \
    virtual void VAR (gdouble*   v)   {  _##VAR = v;  }         \
    virtual void VAR (float*     v)   {  _##VAR = v;  }         \
    virtual void VAR (SVector<N> v)   {  _##VAR = v;  }

#define ARRAY_ATTRIBUTE(VAR, N)                 \
    protected: gfloat _ ## VAR[N];              \
    public:                                     \
    gfloat*  VAR(void) { return _ ## VAR; }     \
    void VAR(gfloat _var_p[N]) {                \
    for(gint i=0; i<N; _##VAR[i++] = _var_p[i]);\
    }


void generate_default_colors(gfloat* color_array, const gfloat* vertex_array, const gint array_length);
void generate_default_colors(VectorArray<gfloat> & color, VectorArray<gfloat> & vertex);
gboolean check_index_ok(VectorArray<gfloat> & array, vector<guint> & index);

void   normalize(gfloat* vec                                               );
void   times    (gfloat* output,   const gfloat* vec, const gfloat escalar );
void   cross    (gfloat* cross,    const gfloat* a,   const gfloat* b      );
void   sum      (gfloat* sum,      gfloat* vec                             );
void   mean     (gfloat* mean,     gfloat* vertex, gint vertex_length      );
void   set      (gfloat* left_hand,const gfloat* right_hand                );
void   normal_v (gfloat* normal,   gfloat* v1, gfloat* v2, gfloat* v3      );
gfloat fit      (const gfloat n,   const gfloat min, const gfloat max      );

void   util_farest_vertex (gfloat* vertex, gint length, gfloat* center, gfloat* radius);
gint   triangle_number    (gint n);
gfloat z_distance         (gfloat* vertex, gint length, gfloat* origin, gfloat fovy);

template <class T> T& part(T* array, gint x, gint y);

FILE* open_file (gchar* name);

void rotate_about (Transformations & tr);

void calc_bbox(VectorArray<gfloat> & array, SVector<6,gfloat> & bbox);


namespace superficie {
    void    plus    (gfloat* output, gfloat* vec1, gfloat* vec2);
    void    minus   (gfloat* output, gfloat* vec1, gfloat* vec2);
}


#ifndef PI
#define PI 3.1415926535F
#endif

const gint VECTOR_LENGTH = 3;


#endif /* __UTIL_H */

